#!/usr/bin/perl
# CONFIG: Change the first line to indicate the Perl binary on your system.
#          Try "which perl", "whereis perl", or "find / -name perl -print"

############################################################## -*- Perl -*- ###
#                                                                          
#     AccessWatch v2.0 - Traffic analysis for World Wide Web sites          
#      Copyright 1994-1998 David G. Maher. All rights reserved.          
#      http://accesswatch.com/                                              
#                                                                           
#     Contact Information:                                                  
#        AccessWatch                                                          
#        PO Box 183, Fairfax, VA 22030-0183 USA                               
#                                                                             
#     Please direct comments to:                                              
#        http://accesswatch.com/comments.html                                 
#                                                                             
#     Please read the included license agreement (readme.txt) before          
#      using this program. Your use of this software indicates your           
#      acceptance of the license agreement and warranty.                      
#                                                                             
#     If you wish to modify this code, mail changes@accesswatch.com.
#     We don't have a problem with modifications by registered users,
#     but redistribution is prohibited. Just write us first.
#                                                                             
#  Credits and thanks for great ideas:
#
#   A huge thank you to Paul Blackman <ictinus@lake.canberra.edu.au> for      
#   his work on hourly server statistics, including a table of hourly       
#   accesses/hour.                                                          
#                                                                           
#   Thanks to Jeff Boulter <jeff@boulter.com> for access error        
#   exclusion code, referer log parsing tips, and for his many suggestions  
#   and debugging help.                                                     
#                                                                           
#   Many thanks for suggestions and code tweaks:                              
#
#      Chris Brown     <cwb3@ra.msstate.edu>                                
#      Ron Gery        <rong@halcyon.com>                                   
#      Lars Bo Eriksen <lb@iesd.auc.dk>                                     
#      Tieshy Lin      <ted@iis.sinica.edu.tw>                              
#      Chris Derossi   <derossi@genmagic.com>                               
#      Arthur Hagen    <art@broomstick.com>                                 
#      Eric Ruck       <eruck@ahoynet.com>                                  
#                                                                           
###############################################################################

###############################################################################
########     NO MODIFICATIONS MAY BE MADE TO THE FOLLOWING CODE        ########
########            WITHOUT THE CONSENT OF THE AUTHOR                  ########
###############################################################################

require 'timelocal.pl' 
    || die "Error: Trouble locating timelocal.pl "
             . "- contact your system administrator $!\n";

require 'lib/global.lib'
    || die "Error: Global file not found $!\n"; 

require 'lib/report.lib' 
    || die "Error: Reporting file not found $!\n"; 

require 'lib/table.lib' 
    || die "Error: Table generation file not found $!\n"; 

require 'lib/db.lib' 
    || die "Error: Database access file not found $!\n"; 

require 'lib/time.lib' 
    || die "Error: Time library file not found $!\n"; 

##############################################################################

#-----------------------------------------------------------------------------#
#  AccessWatch function - Main
#    Purpose  : Coordinates everything else...
#-----------------------------------------------------------------------------#

MAIN: {

    print "Accesswatch v$version Report Generator\n" if $verbose;
    print "Reading stats summary...\n" if $verbose;
    &openTables(0);
    print "Generating static HTML Report...\n" if $verbose;
    &PrepareStaticReport;
    print "Done.\n" if $verbose;

}

__END__
