

import java.applet.*;
import java.awt.*;


public class BinaryTreeApplet extends Applet implements Runnable {

  Thread thread;      // a thread 
  Image treeImage;        // for double buffering
  Image finalImage;  
public RandomDataGenerator rtg;  
  Tree tree;
  int height;
  int treeWidth;  //actual width to draw the tree
  int treeHeight;
  int margin;
  Image surfer ;
  
  
 
  // Override java.applet.Applet.init:
public void init () {
  rtg=new RandomDataGenerator();
  Image fullNode = getImage(getCodeBase(),"red.gif");
  Image emptyNode =getImage(getCodeBase(),"white.gif");
  tree=new Tree(fullNode,emptyNode);  
  treeImage= createImage( getSize().width, getSize().height );
  finalImage= createImage (getSize().width, getSize().height );
  height=5;
  margin=10;
  
  treeWidth=getSize().width-2*margin;
  treeHeight=getSize().width-2*margin;
  surfer=getImage(getCodeBase(),"green.gif");

  //setBackground(Color.lightGray.lighter());
}

  // Override java.applet.Applet.start:
public void start() {
  if (thread == null) {
    // Reinitialize:
    thread = new Thread(this);
    thread.start();
  }
}
  
  // Override java.applet.Applet.stop:
public void stop() {
  if (thread != null) {
    thread.stop();
    thread = null;
  }
}
  
  // Implement java.lang.Runnable.run:
public void run() {
  while(thread != null) {
    Data d=rtg.generateBinData();
    System.out.print(".");
    
    tree.insert(d,this);
    drawTree();

    try {
      Thread.sleep(60);
    } 
    catch(InterruptedException e) {
      // Do nothing   
    };
  }
}

public void moveOneNode(int sx,int sy,int tx,int ty)
  {
    double dy=3;
    
    double steps= (ty-sy)/dy;
    
    double dx=(tx-sx)/steps;
    double x=sx;
    double y=sy;
    
    Graphics g = finalImage.getGraphics(); 
    g.setColor( Color.yellow );

    for (int i=0;i<steps;i++){
      g.drawImage(treeImage, 0, 0, this);
      //g.fillRect((int)x,(int)y,5,5);
      //g.drawRect((int)x,(int)y,5,5);
      g.drawImage(surfer,(int)x,(int)y,this);
      
      //calculate coordintes
      repaint();
      x+=dx;
      y+=dy;
      try {
        Thread.sleep(30);
      } 
      catch(InterruptedException e) {
        // Do nothing   
      };
      
    }
    
  }
public void setStatus(String s)
  {
    Graphics g = treeImage.getGraphics(); 
    g.clearRect(0,getSize().height -30,getSize().width,20);
    g.drawString(s, 10,getSize().height -20);
    
  }
  


public void update(Graphics g) 
  {
    paint(g);
    
  }
  

public void drawTree()
  {
    int vertical=0;

    
    Graphics g = treeImage.getGraphics(); 
   
    
    g.clearRect(0,0,getSize().width, getSize().height );


    vertical=treeHeight/(tree.height +1);
    


    tree.setPosition(treeWidth/2+margin,margin);
    tree.traverse(tree.root,treeWidth,vertical/2,g);
    //   System.out.println(treeWidth+" "+vertical+" "+" "+margin  +" "+ treeHeight  +" "+ tree.height );


    Graphics og = finalImage.getGraphics(); 
    og.drawImage(treeImage, 0, 0, this);
    repaint();
  }
  
  // Override java.awt.Component.paint:
public void paint(Graphics g) {
  g.drawImage(finalImage, 0, 0, this);
}
  
}

class RandomDataGenerator{


public Data  generateBinData()
  {
    double X= Math.random();
    double Y= Math.random();
    return new Data(X,Y);
     
  }
 
  


}

