
import java.awt.*;

public class Tree
{
  double x,y,len;
  Node root;
  int height;
  int numOfpoints;
  Image fullNode,emptyNode;
  Color shadow;
  int l; //node image size
  
  public Tree()
  {
    this.x = 0;
    this.y = 0;
    this.len = 1;
    this.height = 0;
    this.numOfpoints=0;
    this.root = null;
    //   fullNode =Toolkit.getDefaultToolkit().getImage(app.getDocumentBase()+"/red.gif");
    // emptyNode =Toolkit.getDefaultToolkit().getImage(Applet.getDocumentBase()+"/white.gif");
    shadow= new Color(150,150,150);

  }
  public Tree(Image _fullNode,Image _emptyNode)
  {
    this.x = 0;
    this.y = 0;
    this.len = 1;
    this.height = 0;
    this.numOfpoints=0;
    this.root = null;
    shadow= new Color(150,150,150);
    fullNode=_fullNode;
    emptyNode=_emptyNode;
    l=14;
    
    
  } 

  public Tree(double x, double y, double len)
  {
    this.x = x;
    this.y = y;
    this.len = len;
    this.height = 0;
    this.root = null;
     this.numOfpoints=0;
  }

  public void processNode(Node node,Graphics g) 
  {

    if( node.nodes == null && node.data == null)
      {
	//g.setColor(Color.white);
	g.setColor(shadow); //Color.white.darker()); //gray.brighter() ); //.gray.brighter()  );
	//g.setXORMode(Color.gray );
	g.fillOval(node.gx+10,node.gy+3, 15 ,   15 ) ;
	g.drawImage(emptyNode,node.gx,node.gy,null);
	//g.setColor(Color.blue);
	//g.drawRect(node.gx,node.gy, 20 ,   20 ) ;
// draw square at node.gx and node.gy
      }
    else 
      {
        g.setColor(shadow);//((shadow);Color.white.darker());
	g.fillOval(node.gx+10,node.gy+3, 15 ,   15 ) ;

	g.drawImage(fullNode,node.gx,node.gy,null);
// draw circle at node.gx and node.gy
      }
  };

public void   setPosition(int x, int y)
  {
    root.gx=x;
    root.gy=y;
  }
  

  // For the first call, traverse is called with the root node.
  // x and y coordinates of the root node are set in advance,
  // i.e.
  //       root.gx = some_x_value;
  //       root.gy = some_y_value;
  //       traverse(root);
  //
  public void traverse(Node node,int treeWidth ,int vert,Graphics g)
  {
    g.drawImage(fullNode,-100,-100,null);
    if(node != null) 
      {
	int children = (int)Math.pow(5,node.level+1);
	
	
        int horl2= treeWidth/(2*children);
	//System.out.println(horl2+" "+vert+" "+children+" "+node.level);
	
        processNode(node,g);
	
        if(node.nodes != null) {

  	      node.nodes[0].gx=node.gx-3*horl2;
	      node.nodes[1].gx=node.gx-  horl2;
	      node.nodes[2].gx=node.gx+  horl2;
	      node.nodes[3].gx=node.gx+3*horl2;

	      node.nodes[0].gy=node.gy+vert;
	      node.nodes[1].gy=node.gy+vert;
	      node.nodes[2].gy=node.gy+vert;
	      node.nodes[3].gy=node.gy+vert;

	  for(int i=0; i<4; i++) 
	    {
	      // calculate node.nodes[i].gx and node.nodes[i].gy 
	      //from node.gx,node.gy, and node.node.nodes[i].level
	      g.setColor(shadow);//(Color.white.darker()); //Color.white.darker().darker());
              g.drawLine(node.gx+6+10,node.gy+12+3,node.nodes[i].gx+6+10,node.nodes[i].gy+6+3);
	      g.setColor(Color.black);
	      g.drawLine(node.gx+6,node.gy+12,node.nodes[i].gx+6,node.nodes[i].gy+6);
	      
	      traverse(node.nodes[i],treeWidth,vert,g);
	    }
	}
	
      }
  }
  public void insert(Data data,BinaryTreeApplet applet)
  {
    this.numOfpoints++;
    
    //System.out.println( "data.x: " + data.x + "  data.y: " + data.y);
    if( root == null )
      {
        // if there is no root at the first insertion,
        // create the root node with the values x=0.0, y=0.0,
        // the length len=1.0, and the level=0.
        // these values are taken from the tree's x,y,len values.
        root = new Node(x,y,len,0);
        // also save the first data as the root's data.
        root.data = data;
      }
    else // otherwise, tree needs to be expanded.
      {
        Node currnode = root;
        while( !( currnode.nodes == null && currnode.data == null )) 
          {
	    //          System.out.println( "while1 ");

            while( currnode.nodes != null )
              {
		//              System.out.println( "while2 ");
                for(int i=0; i<4; i++)
                  if(currnode.nodes[i].inBox( data ))
                    {
		      applet.setStatus("Number of insertions "+ this.numOfpoints+ " Current data x,y=  "+ data.x+","+data.y+". Now comparing with box "+ currnode.nodes[i].x+","+currnode.nodes[i].y+","+currnode.nodes[i].len+"." );
		      
		      applet.moveOneNode(currnode.gx-3,currnode.gy,currnode.nodes[i].gx-3,currnode.nodes[i].gy);
		    
		      currnode = currnode.nodes[i];
                      break;
                    }
              }
            if(currnode.data != null) 
              {
                currnode.nodes = new Node[4];
                currnode.nodes[0] = 
                  new Node( currnode.x, currnode.y, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[1] = 
                  new Node( currnode.x, currnode.y+currnode.len/2, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[2] = 
                  new Node( currnode.x+currnode.len/2, currnode.y, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[3] = 
                  new Node( currnode.x+currnode.len/2, currnode.y+currnode.len/2
, 
                            currnode.len/2, currnode.level+1);

                for(int i=0; i<4; i++)
                  if(currnode.nodes[i].inBox( currnode.data ))
                     {
                       currnode.nodes[i].data = currnode.data;
                       currnode.data = null;
                       break;
                     }
		if(height < (currnode.level+1))
		  height = currnode.level+1;
		applet.drawTree();
              } // end if

          } // end while

        currnode.data = data;
        if(height < currnode.level)
          height = currnode.level;

      } // end if-else

  } // end insert
}



