/*
 * 
 * Copyright (C) 1996 Michael Woodson <n9442097@fozzie.cc.wwu.edu>
 *
 * Program: btPanel.java
 * 
 * Author: Michael Woodson
 * 
 * E-mail: n9442097@fozzie.cc.wwu.edu
 *
 * Date: March 16, 1996
 * 
 * Please send suggestions to the above e-mail address.
 * 
 * This applet is intended to be used as a learning tool for concepts in
 * binary trees.
 *
 */

import java.applet.*;
import java.awt.*;
import btPanel;

public class BinaryTreeViewer extends Applet 
{
   btPanel btp;
   
   public void init() 
   {
      setLayout(new BorderLayout());
      
      btp = new btPanel(this);
      nodeBalance nb = new nodeBalance();
      btp.add(nb);
      add("center",btp);
	btp.update(getGraphics());
   }
   public void start() 
   {
      btp.start();
   }
   public void stop()
   {
      btp.stop();
   }
   
}


class nodeBalance extends Builder {  
  btNode nextbiggest(btNode tree) {
    btNode temp,last;
    if (tree.left.right == null) {
      temp = tree.left;
      tree.left = temp.left;
      temp.left = null;
    }
    else {
      last = tree.left;
      temp = tree.left.right;
      while (temp.right != null) {
	last = temp;
	temp = temp.right;
      }
      last.right = temp.left;
      temp.left = null;
    }
    temp.left=temp.right=null;
    return temp;
  }

  btNode nextsmallest(btNode tree) {
    btNode temp,last;
    if (tree.right.left == null) {
      temp = tree.right;
      tree.right = temp.right;
      temp.right = null;
    }
    else {
      last = tree.right;
      temp = tree.right.left;
      while (temp.left != null) {
	last = temp;
	temp = temp.left;
      }
      last.left = temp.right;
      temp.right = null;
    }
    temp.left=temp.right=null;
    return temp;
  }
  
  int count(btNode tree) {
    if (tree == null) return 0;
    else return 1 + count(tree.left) + count(tree.right);
  }
  
  btNode balance(btNode tree) {
    int check = count(tree.left)-count(tree.right);
    if (check > 1) {
      btNode temp = nextbiggest(tree);
      int oldkey = tree.key;
      tree.key = temp.key;
      temp.key = oldkey;
      if (tree.right != null) tree.right.add(temp);
      else tree.right = temp;
    }
    else if (check < -1) {
      btNode temp = nextsmallest(tree);
      int oldkey = tree.key;
      tree.key = temp.key;
      temp.key = oldkey;
      if (tree.left != null) tree.left.add(temp);
      else tree.left = temp;
    }
    if (tree.right != null) balance(tree.right);
    if (tree.left != null) balance(tree.left);
    return tree;
  }

  public btNode add(btNode x,btNode tree){
    tree.add(x);
    return tree = balance(tree);
  }
}
