/*
 * EventTest Java Program
 */
/*TANGO*/    // TANGO API classes for collaborative framework
/*TANGO*/    import interfaces.AppletBase;
/*TANGO*/    import messages.*;
/*TANGO*/    import consts.*;

import java.applet.*;
import java.awt.*;

/*TANGO*/ public class EventTest extends AppletBase {
/*TANGO*/   boolean Master = true;   // to indicate master/slave status
/*TANGO*/   boolean myOwnAction = true;   // to indicate master/slave status
    int maxObj = 4;     /* max object number */
    mPoint object[];    /* objecct array */
    Image img;
    int current = -1, hit = -1;
    int xofs = 0, yofs = 0;
  int cursor=3;
    public void init() {
/*TANGO*/      register();   // TANGO registration, this is the first method called in init method
      /* initial object array */
      setBackground(Color.black);
      setForeground(Color.white);
      object = new mPoint[maxObj];
      /* initial a rectangle */
      object[0] = new mRectangle(10, 10, 100, 100);
      object[0].setColor(Color.red);
      /* initial a circle */
      object[1] = new mCircle(200, 10, 100, 100);
      object[1].setColor(Color.red);
      /* initial a triangle */
      object[2] = new mTriangle(10, 200, 100, 100);
      object[2].setColor(Color.red);
      /* cursor */
      object[3] = new mCircle(200, 10, 10, 10);
      object[3].setColor(Color.white);
      
      img = createImage(size().width, size().height);
    }
    /* this method will be called to repond a repaint */
    public void paint(Graphics g) { update(g);}
    /* this method will be called to repond a disclosure */
    public void update(Graphics g) {
        /* Get Off Screen Graphics Context */
        Graphics og = img.getGraphics();
        /* fill background */
        og.setColor(getBackground());
        og.fillRect(1, 1, size().width-2, size().height-2);
        /* draw boundry */
        og.setColor(getForeground());
        og.drawRect(0, 0, size().width-1, size().height-1);
        /* draw objects */
        for (int i=0; i<maxObj-1; i++)
          object[i].paint(og);
        /* user who call getGraphics should call dispose */
	og.setColor(Color.white);
	object[cursor].paint(og);
        og.dispose();
        g.drawImage(img, 0, 0, this);
    }
    /* Mouse Move Event */
    public boolean mouseMove(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/   tangoSend("move:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;

        int i;
        hit = -1;
        for (i=0; i<maxObj-1; i++) {
          if ( object[i].isInside(x, y) ) {
            hit = i;
            break;
          }
        }
        for (i=0; i<maxObj-1; i++)
          object[i].setColor((i==hit) ? Color.cyan : Color.red);
	object[cursor].moveTo(x, y);
        repaint();
	showStatus("Mouse x,y: "+Integer.toString(x)+","+Integer.toString(x));
	
        return true;
    }
    /* Mouse Down Event */
    public boolean mouseDown(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/  tangoSend("down:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;
        current = hit;
        if ( current != -1 ) {
          xofs = object[current].x-x;
          yofs = object[current].y-y;
        }
	object[cursor].setSize(20,20);
        return true;
    }
    /* Mouse Drag Event */
    public boolean mouseDrag(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/  tangoSend("drag:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;
        if ( current != -1 ) {
          object[current].moveTo(x+xofs, y+yofs);
	  //   repaint();
        }
	object[cursor].moveTo(x, y);
        repaint();
	showStatus("Mouse x,y: "+Integer.toString(x)+","+Integer.toString(x));
        return true;
    }
    /* Mouse Up Event */
    public boolean mouseUp(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/  tangoSend("up:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;
        current = -1;
	object[cursor].setSize(10,10);
        return true;
    }
    /* Mouse Enter Event */
    public boolean mouseEnter(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/  tangoSend("enter:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;
        setForeground(Color.cyan);
        repaint();
        return true;
    }
    /* Mouse Exit Event */
    public boolean mouseExit(Event ev, int x, int y) {
/*TANGO*/if (Master)
/*TANGO*/  tangoSend("exit:"+Integer.toString(x)+","+Integer.toString(y));
/*TANGO*/else if (myOwnAction) return true;
        setForeground(Color.red);
        repaint();
        return true;
    }
    /* KeyDown Event */
    public boolean keyDown(Event ev, int key) {
        if ( hit == -1 ) return false;
        int dx = 0, dy = 0;
        switch ( key ) {
          case Event.DOWN:
            dy = 1;
            break;
          case Event.UP:
            dy = -1;
            break;
          case Event.LEFT:
            dx = -1;
            break;
          case Event.RIGHT:
            dx = +1;
            break;
        }
        if ((dx != 0) || (dy != 0)) {
          object[hit].move(dx, dy);
          repaint();
        }
        return true;
    }
/*TANGO*/    public void tangoSend(String str)  {
/*TANGO*/            /* Send events over TANGO */
/*TANGO*/              int len=str.length();
/*TANGO*/              // prepare message to be sent by TANGO runtime
/*TANGO*/              byte[] t=new byte[len];
/*TANGO*/              str.getBytes(0,len,t,0);
/*TANGO*/             AppEventMessage em=new AppEventMessage(Const.DATA,t);
/*TANGO*/             send(em); 
 
  }
  
/*TANGO*/    // recieve events from Mater (Slave Only), this method is required
/*TANGO*/    public void receive (AppEventMessage em) {
/*TANGO*/      try {
/*TANGO*/          // by default, when a new instance joins, it gets an master/slave message
 /*TANGO*/           if (em.getType() == Const.CONTROL) {
/*TANGO*/                    CAppAnswerEventMessage msg =  (CAppAnswerEventMessage) em;
/*TANGO*/                    if (msg.getAnswerType() == CAConsts.ISMASTER) {
/*TANGO*/                            Master = msg.isMaster(); // update master/slave status
/*TANGO*/                            if (Master) System.out.println ("I am master");
/*TANGO*/                            else System.out.println ("I am slave");
/*TANGO*/                    }
/*TANGO*/                    return;
/*TANGO*/          }
/*TANGO*/
/*TANGO*/          // slave decides what to do upon the event received  from the master
/*TANGO*/          String str=new String(em.getData(),0,0,em.getLen()); // decode the message into a String
/*TANGO*/          int cl=str.indexOf(":");
/*TANGO*/          int cm=str.indexOf(",");
/*TANGO*/          int x=Integer.parseInt(str.substring(cl+1,cm));
/*TANGO*/          int y=Integer.parseInt(str.substring(cm+1));
/*TANGO*/          myOwnAction=false;
/*TANGO*/          if (str.startsWith("move"))
/*TANGO*/            mouseMove(null,x,y);
/*TANGO*/          else  if (str.startsWith("down")) 
/*TANGO*/            mouseDown(null,x,y);
/*TANGO*/          else  if (str.startsWith("drag")) 
/*TANGO*/            mouseDrag(null,x,y);
/*TANGO*/          else  if (str.startsWith("up")) 
/*TANGO*/             mouseUp(null,x,y);
/*TANGO*/          else  if (str.startsWith("enter")) 
/*TANGO*/             mouseEnter (null,x,y);
/*TANGO*/          else  if (str.startsWith("exit")) 
/*TANGO*/             mouseExit (null,x,y);
/*TANGO*/          myOwnAction=true;
/*TANGO*/      }
/*TANGO*/      catch (Exception e) {
/*TANGO*/        e.printStackTrace();
/*TANGO*/      }
/*TANGO*/    }
}
