    import java.applet.*;
    import java.awt.*;
    import java.net.URL;

    // TANGO API classes for collaborative framework
    import interfaces.AppletBase;
    import messages.*;
    import consts.*;

    //note you must extends AppletBase instead of Applet
    public class Search extends AppletBase {
    private TextField tf;
    private AppletContext ac;
    boolean Master = true;   // to indicate master/slave status
      
    public void init() {
      register();   // TANGO registration, this is the first method called in init method
      add(tf=new TextField(30)); // text field to get URL
      add(new Button("Submit"));
      ac=this.getAppletContext();
    }
    public boolean action(Event ev,Object o) {
      if (!Master) return true;   // only master can act. If you want to run the
                                  // applet in Master-Master mode, comment out this line
      if (o.equals("Submit")) {
        try {
              String tmp=tf.getText();      
              URL u=new URL(tmp);   
              ac.showDocument(u,"browser");

            /* Send events over TANGO */
              // prepare message to be sent by TANGO runtime
              byte[] t=new byte[tmp.length()];
              tmp.getBytes(0,tmp.length(),t,0);
              AppEventMessage em=new AppEventMessage(Const.DATA,t);
              send(em); 
        }
        catch (Exception e) {
          e.printStackTrace();
        }
        return true;
      }
      return false;
    }

    // recieve events from Mater (Slave Only), this method is required
    public void receive (AppEventMessage em) {
      try {
          // by default, when a new instance joins, it gets an master/slave message
            if (em.getType() == Const.CONTROL) {
                    CAppAnswerEventMessage msg =  (CAppAnswerEventMessage) em;
                    if (msg.getAnswerType() == CAConsts.ISMASTER) {
                            Master = msg.isMaster(); // update master/slave status
                            if (Master) System.out.println ("I am master");
                            else System.out.println ("I am slave");
                    }
                    return;
          }

          // slave decides what to do upon the event received  from the master
          String r=new String(em.getData(),0,0,em.getLen()); // decode the message into a String
          URL u=new URL(r); 
          ac.showDocument(u,"browser"); // display the URL's content in a HTML browser
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }
    }
